#!/usr/bin/perl
#
# This script allows playing a Trivial-like game
#
# Author: ryu@gpul.org
#
# It's designed for X-Chat
#
# This script is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or   
# (at your option) any later version.

# This script is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details.

# You can read the GNU General Public License at http://www.gnu.org

my $BANNER="\0038[\0037X-Chat trivial\0038]\003";

my $trivial_db="$ENV{HOME}/.xchat/trivial.db";
my $cfg_file="$ENV{HOME}/.xchat/trivial.conf";
srand;

my $active=0;

my @datos=();
my $cuantos=0;
my $respuesta="";
my $channel=0;

my @puntos=();
my $acertada=0;
my $timeout=0;

my $no_preguntados=0;

my $final=45;

my $tiempo_respuesta=25;
my $tiempo_siguiente=2;

if (open(F,"<$cfg_file")) {
  while(<F>) {
    if (/([^= ])* *= *([^ ]*)/) {
        my $var=$1;
        my $val=$2;
        if ($var=="tiempo_respuesta") {
          $tiempo_respuesta=$val;
        }elsif ($var=="tiempo_siguiente") {
          $tiempo_siguiente=$val;
        }elsif ($var=="limite_preguntas") {
          $final=$val;
        }
    }
  }
}

IRC::add_command_handler("trivial","trivial_hnd");
IRC::add_message_handler("PRIVMSG", "trivial_privmsg_handler");

sub obtpunt
{
  my $val=shift;
  $val=~/^([^:]*):(.*)$/;
  return $2;
}

sub puntuaciones
{
  my $n=0;
  my $msg="$BANNER\0034";
  my @ordenados=sort {obtpunt($b) <=> obtpunt($a)} @puntos;
  for (@ordenados){
    IRC::print("{$_}");
    /^([^:]*):(.*)$/;
    my $nick=$1;
    my $puntos=$2;
    if ($n==0) {
      my $dif=$final - $puntos;
      if ($dif < 10) {
        if ($dif==0) {
          trivial_hnd();
        }
        $dif=0 - $dif;
        IRC::send_raw("PRIVMSG $channel :$BANNER $nick\0033 $dif\003\n");
      }
    }
    $n++;
    if ($n<=5) {
      $msg="$msg \00311$nick\00310:\0036 $puntos";
    }
  }
  IRC::send_raw("PRIVMSG $channel :$msg\003\n");
}

sub busca
{
  my $nick=shift;
  my $i=0;
  for(@puntos){
    if (/^$nick:/){
      return $i;
    }else{
      $i++;
    }
  }
  $puntos[$i]="$nick:0";
  return $i;
}

sub inc
{
  my $nick=shift;
  my $pos=busca($nick);
  
  $puntos[$pos]=~/^$nick:(.*)$/;
  my $punt=$1 + 1;
  $puntos[$pos]="$nick:$punt";
}

sub trivial_privmsg_handler
{
    if ($timeout) {return 0}
    # Leemos la lnea con el mensaje proviniente del servidor
	my $line = shift(@_);

    # Dividimos la lnea en partes para quedarnos con el nick, la mask
    # y el mensaje 
    $line =~ /^:(.*)!(.*@.*) PRIVMSG .*:(.*)$/;
    my $su_nick= $1;
    my $mask = $2;
    my $msg  = $3;
    
    if ($msg=~/^$respuesta[s]?$/i
     || $msg=~/ $respuesta[s]? /i
     || $msg=~/^$respuesta[s]? /i
     || $msg=~/ $respuesta[s]?$/i) {
      inc($su_nick);
      $acertada=1;
      $timeout=1;
      IRC::send_raw("PRIVMSG $channel :$BANNER\0034 $su_nick ha acertado, la respuesta era: \0035\002$respuesta\002\003\n");
      puntuaciones();
    }
    return 0;
}


cargar();

sub cargar
{
    my $pregunta=0;
    my $respuesta=0;
    if (open(F,"<$trivial_db")) {
      $/="\n";
      while(<F>) {
        if (/^([^]*)[^]*([^\*]*)\*([^\r\n]*)/) {
          my $tema=$1;
          my $preg=$2;
          my $resp=$3;
          $resp=~s/\+/\\+/g;
          $resp=~s/\$/\\\$/g;
          $resp=~s/\!/\\!/g;
          $resp=~s/\[/\\[/g;
          $resp=~s/\]/\\]/g;
          push @datos,"$tema|$preg|$resp";
        }elsif (/^([^\*]*)\*(.*).$/){
          my $preg=$1;
          my $resp=$2;
          $resp=~s/\+/\\+/g;
          $resp=~s/\$/\\\$/g;
          $resp=~s/\!/\\!/g;
          $resp=~s/\[/\\[/g;
          $resp=~s/\]/\\]/g;
          push @datos,"general|$preg|$resp";
        }
      }
      $cuantos=$#datos+1;
      $no_preguntados=$cuantos;
      IRC::print("$BANNER: $cuantos preguntas\n");
      close(F);
    }else{
        IRC::print("Error cargando base de datos\n");
    }
}

sub trivial_hnd
{
    $active=(not $active);
    if ($active) {
        $channel=IRC::get_info(2);
        IRC::send_raw("PRIVMSG $channel :$BANNER\0034 Empieza el juego del Trivial!\n");
        IRC::print("$BANNER\0034 Empieza el juego del Trivial!\n");
        @puntos=();
        preguntar();
    }else{
        IRC::send_raw("PRIVMSG $channel :$BANNER\0034 El juego de Trivial ha sido detenido\n");
        IRC::print("$BANNER\0034 El juego de Trivial ha sido detenido\n");
    }
    return 1;
}

sub timeout
{
    if (not $active) {return}
    if (not $acertada) {
      IRC::send_raw("PRIVMSG $channel :$BANNER\0034 Se acab el tiempo, la respuesta era: \0035\002$respuesta\002\003\n");
      $timeout=1;
      IRC::add_timeout_handler(1000*$tiempo_siguiente,"preguntar");
    }else{
      $acertada=0;
      preguntar();
    }
}

sub preguntar
{
    if (not $active) {return}
    if ($no_preguntados==0) {
      $no_preguntados=$cuantos;
      IRC::send_raw("PRIVMSG $channel :$BANNER\0033 Se acabaron las preguntas, repetimos!\003\n");
    }
    my $pos=int(rand($no_preguntados));
    my $item=$datos[$pos];
    $item=~/^([^\|]*)\|([^\|]*)\|(.*)$/;
    my $tipo=$1;
    my $preg=$2;
    $respuesta=$3;
    my @p=split(/ /,$respuesta);
    my $palabras=$#p+1;
    $timeout=0;
    IRC::send_raw("PRIVMSG $channel :$BANNER\0035 $tipo\003: \0034$preg ($palabras palabras)\003\n");
    IRC::add_timeout_handler(1000*$tiempo_respuesta,"timeout");
    $no_preguntados--;
    splice(@datos,$pos,1);
    push(@datos,$item);
}

IRC::print("$BANNER Ready!\n");
